//+------------------------------------------------------------------+
//|                                                       TEST 4.mq4 |
//|                                                        ARRESSS23 |
//|                                          driss.elbaz23@gmail.com |
//+------------------------------------------------------------------+
#property copyright "ARRESSS23"
#property link      "driss.elbaz23@gmail.com"
#property version   "1.00"
#property strict

extern double lot_buy;
extern double lot_sell_1;
extern double lot_sell_2;
extern int slippage;
extern int distance;
extern int magic;

int ticket_buy;
int ticket_sell_1;
int ticket_sell_2;
double price_open_buy;
double pt;
bool trade=true;


bool AreThereOrders()
  {
   int i;
   for(i=OrdersTotal()-1; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderMagicNumber()==magic && OrderSymbol()==Symbol())
        {
         return (true);
        }
     }
   return (false);
  }


    

void error_fonction (int position)
  {
   if(position<0)
      {
       Print("OrderSend failed with error #",GetLastError());
      }
      else
      {
      Print("OrderSend placed successfully"); 
      }
  }




//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  { 
  if(Digits==5||Digits==4) 
    { 
     pt=0.0001; 
    } 
  else 
    { 
     pt=0.01; 
    }

   
   return(INIT_SUCCEEDED);
  }


//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }


//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  { 

   
// Send alert message in case of loss of connection with the server:   
   if ( IsConnected () == false )
     {
      Comment ( "ALERT : ECHEC OF CONNECTION" );
      return;
     }
   
     
       
  
     
// Execution of the first buy order:
   if(AreThereOrders()==false)
    {
     ticket_buy=OrderSend(Symbol(),OP_BUY,lot_buy,Ask,slippage,(Ask-(distance*2*pt)),(Ask+(distance*2*pt)),NULL,0,0,0);     
     error_fonction (ticket_buy); 
    }
   
   
  
// Return the Buying price and stock it in the variable: price_open_buy
   if(OrderSelect(ticket_buy,SELECT_BY_TICKET)==True)  
   price_open_buy=OrderOpenPrice();                
       

   
    
   
// Execution of 2nd order of sale when price goes up:
   if ( (trade==true) && ( NormalizeDouble(Ask,5) == NormalizeDouble(price_open_buy,5) + NormalizeDouble((distance*pt),5) )) 
            {
                   ticket_sell_1=OrderSend(Symbol(),OP_SELL,lot_sell_1,Bid,slippage,(Bid+(distance*pt)),(Bid-(distance*3*pt)),NULL,0,0,0);      
                   error_fonction (ticket_sell_1);
                   trade=false;
            }
               
            
        
// Execution of 2nd order of sale when price goes down :   
   if ( (trade==true) && ( NormalizeDouble(Ask,5) == NormalizeDouble(price_open_buy,5) - NormalizeDouble((distance*pt),5)) )
   
           {
            
               ticket_sell_2=OrderSend(Symbol(),OP_SELL,lot_sell_2,Bid,slippage,(Bid+(distance*3*pt)),(Bid-(distance*pt)),NULL,0,0,0);      
               error_fonction (ticket_sell_2);         
               trade=false;
           }
      
   
                
     
         
           
    
  }

//+------------------------------------------------------------------+
